/*************************************************************************
	> File Name: md5_1.cpp
	> Author:chudongfang
	> Mail:1149669942@qq.com
	> Created Time: 20160622  16ʱ1230
 ************************************************************************/

#include <string.h>
#include <math.h>
#include <stdio.h>
#include "md5c.h"
#include "defs.h"

 /***********************************
  * Ժ
  * (&,|ǻ,~Ƿ,^)
  *
  * ЩƵģ
  *   XYZĶӦλǶ;ȵģ
  *   ôÿһλҲӦǶ;ȵġ
  *
  * FǰλʽXôYZ
  * Hλż
  **********************************/
#define F(x,y,z) ((x & y) | (~x & z))  
#define G(x,y,z) ((x & z) | (y & ~z))  
#define H(x,y,z) (x^y^z)  
#define I(x,y,z) (y ^ (x | ~z))  

  /**************************************
   *һnλ
   * ************************************/
#define ROTATE_LEFT(x,n) ((x << n) | (x >> (32-n)))  

   /****************************************************
	* ÿβabcdеһηԺ
	*  F(b,c,d)   G(b,c,d)   H(b,c,d)   I(b,c,d)
	*
	* Ȼý ĸ(a)
	* F(b,c,d)+a
	*
	* ıһӷ(x)
	* F(b,c,d)+a+x
	*
	* һ(ac)
	* F(b,c,d)+a+x+ac
	*
	* ٽýһһ(s)
	* ROTATE_LEFT( F(b,c,d)+a+x+ac , s )
	*
	* abcd֮һ(b)
	* ROTATE_LEFT( F(b,c,d)+a+x+ac , s )+b
	*
	* øýȡabcd֮һ(a)
	* a=ROTATE_LEFT( F(b,c,d)+a+x+ac , s )+b
	*
	* ***************************************************/
#define FF(a,b,c,d,x,s,ac) { a += F(b,c,d) + x + ac;  a = ROTATE_LEFT(a,s); a += b; }
#define GG(a,b,c,d,x,s,ac) { a += G(b,c,d) + x + ac;  a = ROTATE_LEFT(a,s); a += b; }
#define HH(a,b,c,d,x,s,ac) { a += H(b,c,d) + x + ac;  a = ROTATE_LEFT(a,s); a += b; }
#define II(a,b,c,d,x,s,ac) { a += I(b,c,d) + x + ac;  a = ROTATE_LEFT(a,s); a += b; }

	//һλ1 ɸ0,MD5FinalʱĲ
//unsigned char PADDING[] = { 0x80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

unsigned char PADDING[64] = { 0x80 };
const char HEX[16] = {
		'0', '1', '2', '3',
		'4', '5', '6', '7',
		'8', '9', 'a', 'b',
		'c', 'd', 'e', 'f'
};

//ÿ涼нϸ˵ﲻ׸

/************************
 * ܣʼһMD5 text
 * MD5 text ָ
 * ***********************/
 //ʼ
void MD5Init(MD5_CTX *context)
{
	context->count[0] = 0;
	context->count[1] = 0;
	//ֱ𸳹̶ֵ  
	context->state[0] = 993450794;
	context->state[1] = -1945296281;
	context->state[2] = -1553735472;
	context->state[3] = 977475161;
}

/************************************************
 * ܣһMD5 text,ݽз飬м
 * δõݰ䴢MD5 textС
 *
 * 
 * MD5_CTX *context       һMD5 text
 * unsigned char *input   ӵ
 * unsigned int inputlen  ݵĳ(ֽ)
 *
 ***********************************************/

void MD5Update(MD5_CTX *context, unsigned char *input, unsigned int inputlen)
{
	unsigned int i = 0, index = 0, partlen = 0;

	//indexǰ״̬λ64ȡ࣬䵥λֽ
	//Ҳд  index=(context->count[0]/8)%64
	index = (context->count[0] >> 3) & 0x3F;

	//partlen:Բ64ֽڵֽ
	partlen = 64 - index;

	//ǽһunsignde int ޷漫ݵ
	//ǰλӵλinputlenֽΪλתΪλ
	//൱context->count[0] += inputlen*8;  
	context->count[0] += inputlen << 3;

	//ʱͨ²16λһ飬һ
	//32λĶӶ䴢淶Χ
	if (context->count[0] < (inputlen << 3))
		context->count[1]++;

	//滻Ϊ context->count[1]+=(inputlen<<3)>>32;
	//
	context->count[1] += inputlen >> 29;

	//ֽĴԲ64ֽڵֽв
	if (inputlen >= partlen)
	{
		//bufferвpartlenֽڣʹ䵽64ֽ
		memcpy(&context->buffer[index], input, partlen);

		//bufferﵽ64ֽ512λΪһ
		MD5Transform(context->state, context->buffer);

		//ݻɶ64ֽڣ
		//Ϊ
		for (i = partlen; i + 64 <= inputlen; i += 64)
			MD5Transform(context->state, &input[i]);

		//ָ0ֵӦ   ʣֽ(64ֽ) Ĳ
		index = 0;
	}
	//򣬰ݰ˳ԭݺ
	else
	{
		i = 0;
	}

	//ʣ
	memcpy(&context->buffer[index], &input[i], inputlen - i);
}

/*************************************************
 * ܣݽв㣬λϢһ
 *
 * 
 * MD5_CTX *context          :һMD5 text
 * unsigned char digest[16]  :ܽ
 *************************************************/

void MD5Final(MD5_CTX *context, unsigned char digest[16])
{
	unsigned int index = 0, padlen = 0;

	//bits 8ֽڣ64λ
	unsigned char bits[8];

	//index:64ȡ
	index = (context->count[0] >> 3) & 0x3F;
	//ΪҪʹλ512Ľ44856λ
	//ԵʣС56ֽڣ56-indexֽڣ
	//120-indexֽ
	//padlenֽ
	padlen = (index < 56) ? (56 - index) : (120 - index);

	//Ȼ渽һ64λƱʾǰݳȡ
	//ǰݳתŵbitַ
	MD5Encode(bits, context->count, 8);

	//Ѿ洢õPADDINGϢĺһ10
	//ֱʱֹͣ0Ϣ
	//һϵеļܲ䶨ʣ48ֽ
	MD5Update(context, PADDING, padlen);

	//ӽ8ֽڵݳϢճһ飬һμܴ
	MD5Update(context, bits, 8);

	//յõļϢַ16ֽ
	MD5Encode(digest, context->state, 16);
}

/**********************************************************
 * ܣλ1->4ʽַַֽ
 *
 * 
 * unsigned char  *output ַ
 * unsigned int   *input  ֵ
 * unsigned int   len     : ĳȣλλ
 * *********************************************************/

void MD5Encode(unsigned char *output, unsigned int *input, unsigned int len)
{
	unsigned int i = 0, j = 0;
	while (j < len)
	{
		//& 0xFFΪȡ8λ
		//i±
		//jַ±
		//ֵ88-1616-2424-32ֱֵַ
		output[j] = input[i] & 0xFF;
		output[j + 1] = (input[i] >> 8) & 0xFF;
		output[j + 2] = (input[i] >> 16) & 0xFF;
		output[j + 3] = (input[i] >> 24) & 0xFF;
		i++;
		j += 4;
	}
}

/**********************************************************
 * ܣλ4->1ʽַϳ
 *
 * 
 * unsigned int  *output ֵ
 * unsigned char *input  ַ
 * unsigned int  len     : ַĳ λλ
 * *********************************************************/

void MD5Decode(unsigned int *output, unsigned char *input, unsigned int len)
{
	unsigned int i = 0, j = 0;
	while (j < len)
	{
		//λĸλΪ1ֽڵַϳһλΪ4ֽڵ
		//ΪFF GG HH IIͷԺֻֽܶд
		//һַռǰ8λڶռ8-16λռ16-24λĸռ
		//24-32λ
		//i±
		//jַ±
		output[i] = (input[j]) |
			(input[j + 1] << 8) |
			(input[j + 2] << 16) |
			(input[j + 3] << 24);
		i++;
		j += 4;
	}
}

/**************************************************************
* ܣ512λblockݽмܣѼܽstate
* 512λϢ(blockַ)һδÿδ
*state[4]md5ṹеstate[4]ڱ512bitsϢܵмս
* block[64]ܵ512bitsϢм
***************************************************************/
void MD5Transform(unsigned int state[4], unsigned char block[64])
{
	//a b c d̳һܵĽм̳
	unsigned int a = state[0];
	unsigned int b = state[1];
	unsigned int c = state[2];
	unsigned int d = state[3];

	//ֻõ16Ұԭunsiged int x[64]  Ϊ x[16]
	unsigned int x[16];

	//ַת֣
	MD5Decode(x, block, 64);


	char *v2; // r3
	int v3; // r4
	int v4; // r5
	int v5; // r4
	int v6; // r1
	int v7; // r2
	int v8; // r3
	int v9; // r4
	int v10; // r1
	int v11; // r2
	int v12; // r3
	int v13; // r4
	int v14; // ST34_4
	int v15; // r1
	int v16; // r2
	int v17; // r3
	int v18; // r4
	int v19; // r5
	int v20; // r2
	int v21; // r3
	int v22; // r7
	int v23; // r1
	int v24; // r2
	int v25; // r3
	int v26; // r4
	int v27; // r1
	int v28; // r2
	int v29; // r3
	int v30; // r4
	int v31; // r1
	int v32; // r2
	int v33; // r3
	int v34; // r4
	int v35; // r1
	int v36; // r2
	int v37; // r3
	int v38; // r4
	int v39; // r1
	int v40; // r2
	int v41; // r3
	int v42; // r4
	int v43; // r1
	int v44; // r2
	int v45; // r3
	int v46; // r4
	int v47; // r1
	int v48; // r2
	int v49; // r3
	int v50; // r4
	int v51; // r1
	int v52; // r2
	int v53; // r3
	int v54; // r5
	int v55; // r1
	int v56; // r4
	int v57; // r3
	int v58; // r5
	int v59; // r1
	int v60; // r4
	int v61; // r3
	int v62; // r2
	int v63; // r1
	int v64; // r4
	int v65; // r3
	int v66; // r2
	int v67; // r1
	int v68; // r4

	v5 = __ROR4__(x[0] - 680876936 + a + (d & ~b | b & c), 25) + b;
	v6 = __ROR4__(x[1] - 389564586 + d + (c & ~v5 | b & v5), 20) + v5;
	v7 = __ROR4__(x[2] + 606105819 + c + (v5 & v6 | b & ~v6), 15) + v6;
	v8 = __ROR4__(x[3] - 1044525330 + b + (v6 & v7 | v5 & ~v7), 10) + v7;
	v9 = __ROR4__(
		v5 + x[4] - 176418897 + ((__ROR4__(x[2] + 606105819 + c + (v5 & v6 | b & ~v6), 15) + v6) & v8 | v6 & ~v8),
		25)
		+ v8;
	v10 = __ROR4__(
		v6
		+ x[5]
		+ 1200080426
		+ (v8 & v9 | (__ROR4__(
			x[2]
			+ 606105819
			+ c
			+ ((__ROR4__(x[0] - 680876936 + a + (d & ~b | b & c), 25) + b) & v6 | b & ~v6),
			15)
			+ v6) & ~v9),
		20)
		+ v9;
	v11 = __ROR4__(v7 + x[6] - 1473231341 + (v9 & v10 | v8 & ~v10), 15) + v10;
	v12 = __ROR4__(v8 + x[7] - 45705983 + (v10 & v11 | v9 & ~v11), 10) + v11;
	v13 = __ROR4__(v9 + x[8] + 1770035416 + (v11 & v12 | v10 & ~v12), 25) + v12;
	v14 = x[9];
	v15 = __ROR4__(v10 + x[9] - 1958414417 + (v12 & v13 | v11 & ~v13), 20) + v13;
	v16 = __ROR4__(v11 + x[10] - 42063 + (v13 & v15 | v12 & ~v15), 15) + v15;
	v17 = __ROR4__(v12 + x[11] - 1990404162 + (v15 & v16 | v13 & ~v16), 10) + v16;
	v18 = __ROR4__(v13 + x[12] + 1804603682 + (v16 & v17 | v15 & ~v17), 25) + v17;
	v19 = __ROR4__(x[13] - 40341101 + v15 + (v17 & v18 | v16 & ~v18), 20) + v18;
	v20 = __ROR4__(x[14] - 1502002290 + v16 + (v18 & v19 | ~v19 & v17), 15) + v19;
	v21 = __ROR4__(x[15] + 1236535329 + v17 + (v19 & v20 | ~v20 & v18), 10) + v20;
	v22 = __ROR4__(x[1] - 165796510 + v18 + (~v19 & v20 | v19 & v21), 27) + v21;
	v23 = __ROR4__(x[6] - 1069501632 + v19 + (~v20 & v21 | v20 & v22), 23) + v22;
	v24 = __ROR4__(v20 + x[11] + 643717713 + (v22 & ~v21 | v21 & v23), 18) + v23;
	v25 = __ROR4__(v21 + x[0] - 373897302 + (v23 & ~v22 | v22 & v24), 12) + v24;
	v26 = __ROR4__(v22 + x[5] - 701558691 + (v24 & ~v23 | v23 & v25), 27) + v25;
	v27 = __ROR4__(v23 + x[10] + 38016083 + (v25 & ~v24 | v24 & v26), 23) + v26;
	v28 = __ROR4__(v24 + x[15] - 660478335 + (v26 & ~v25 | v25 & v27), 18) + v27;
	v29 = __ROR4__(v25 + x[4] - 405537848 + (v27 & ~v26 | v26 & v28), 12) + v28;
	v30 = __ROR4__(v26 + x[9] + 568446438 + (v28 & ~v27 | v27 & v29), 27) + v29;
	v31 = __ROR4__(v27 + x[14] - 1019803690 + (v29 & ~v28 | v28 & v30), 23) + v30;
	v32 = __ROR4__(v28 + x[3] - 187363961 + (v30 & ~v29 | v29 & v31), 18) + v31;
	v33 = __ROR4__(v29 + x[8] + 1163531501 + (v31 & ~v30 | v30 & v32), 12) + v32;
	v34 = __ROR4__(v30 + x[13] - 1444681467 + (v32 & ~v31 | v31 & v33), 27) + v33;
	v35 = __ROR4__(v31 + x[2] - 51403784 + (v33 & ~v32 | v32 & v34), 23) + v34;
	v36 = __ROR4__(x[7] + 1735328473 + v32 + (v34 & ~v33 | v33 & v35), 18) + v35;
	v37 = __ROR4__(x[12] - 1926607734 + v33 + (v35 & ~v34 | v34 & v36), 12) + v36;
	v38 = __ROR4__(x[5] - 378558 + v34 + (v36 ^ v35 ^ v37), 28) + v37;
	v39 = __ROR4__(x[8] - 2022574463 + v35 + (v37 ^ v36 ^ v38), 21) + v38;
	v40 = __ROR4__(x[11] + 1839030562 + v36 + (v38 ^ v37 ^ v39), 16) + v39;
	v41 = __ROR4__(x[14] - 35309556 + v37 + (v39 ^ v38 ^ v40), 9) + v40;
	v42 = __ROR4__((v40 ^ v39 ^ v41) + x[1] - 1530992060 + v38, 28) + v41;
	v43 = __ROR4__((v41 ^ v40 ^ v42) + x[4] + 1272893353 + v39, 21) + v42;
	v44 = __ROR4__((v42 ^ v41 ^ v43) + x[7] - 155497632 + v40, 16) + v43;
	v45 = __ROR4__((v43 ^ v42 ^ v44) + x[10] - 1094730640 + v41, 9) + v44;
	v46 = __ROR4__((v44 ^ v43 ^ v45) + x[13] + 681279174 + v42, 28) + v45;
	v47 = __ROR4__((v45 ^ v44 ^ v46) + x[0] - 358537222 + v43, 21) + v46;
	v48 = __ROR4__((v46 ^ v45 ^ v47) + x[3] - 722521979 + v44, 16) + v47;
	v49 = __ROR4__((v47 ^ v46 ^ v48) + x[6] + 76029189 + v45, 9) + v48;
	v50 = __ROR4__((v48 ^ v47 ^ v49) + x[9] - 640364487 + v46, 28) + v49;
	v51 = __ROR4__((v49 ^ v48 ^ v50) + x[12] - 421815835 + v47, 21) + v50;
	v52 = __ROR4__(v48 + x[15] + 530742520 + (v50 ^ v49 ^ v51), 16) + v51;
	v53 = __ROR4__(v49 + x[2] - 995338651 + (v51 ^ v50 ^ v52), 9) + v52;
	v54 = __ROR4__(x[0] - 198630844 + v50 + ((~v51 | v53) ^ v52), 26) + v53;
	v55 = __ROR4__(x[7] + 1126891415 + v51 + ((~v52 | v54) ^ v53), 22) + v54;
	v56 = __ROR4__(x[14] - 1416354905 + v52 + ((~v53 | v55) ^ v54), 17) + v55;
	v57 = __ROR4__(v53 + x[5] - 57434055 + ((~v54 | v56) ^ v55), 11) + v56;
	v58 = __ROR4__(x[12] + 1700485571 + v54 + ((~v55 | v57) ^ v56), 26) + v57;
	v59 = __ROR4__(x[3] - 1894986606 + v55 + ((~v56 | v58) ^ v57), 22) + v58;
	v60 = __ROR4__(x[10] - 1051523 + v56 + ((~v57 | v59) ^ v58), 17) + v59;
	v61 = __ROR4__(x[1] - 2054922799 + v57 + ((~v58 | v60) ^ v59), 11) + v60;
	v62 = __ROR4__(x[8] + 1873313359 + v58 + ((~v59 | v61) ^ v60), 26) + v61;
	v63 = __ROR4__(x[15] - 30611744 + v59 + ((~v60 | v62) ^ v61), 22) + v62;
	v64 = __ROR4__(x[6] - 1560198380 + v60 + ((~v61 | v63) ^ v62), 17) + v63;
	v65 = __ROR4__(x[13] + 1309151649 + v61 + ((~v62 | v64) ^ v63), 11) + v64;
	v66 = __ROR4__(x[4] - 145523070 + v62 + ((~v63 | v65) ^ v64), 26) + v65;
	v67 = __ROR4__(x[11] - 1120210379 + v63 + ((~v64 | v66) ^ v65), 22) + v66;
	v68 = __ROR4__(x[2] + 718787259 + v64 + ((~v65 | v67) ^ v66), 17) + v67;
	state[0] = v66 + a;
	state[1] = v68 + b + __ROR4__(v14 - 343485551 + v65 + ((~v66 | v68) ^ v67), 11);
	state[2] = v68 + c;
	state[3] = v67 + d;

	////庯ʽ̶׸

	///*************һ******************/
	//FF(a, b, c, d, x[0], 25, -680876936);
	//FF(d, a, b, c, x[1], 20, -389564586);
	//FF(c, d, a, b, x[2], 15, 606105819);
	//FF(b, c, d, a, x[3], 10, -1044525330);

	//FF(a, b, c, d, x[4], 25, -176418897);
	//FF(d, a, b, c, x[5], 20, 1200080426);
	//FF(c, d, a, b, x[6], 15, -1473231341);
	//FF(b, c, d, a, x[7], 10, -45705983);

	//FF(a, b, c, d, x[8], 25, 1770035416);
	//FF(d, a, b, c, x[9], 20, -1958414417);
	//FF(c, d, a, b, x[10], 15, -42063);
	//FF(b, c, d, a, x[11], 10, -1990404162);

	//FF(a, b, c, d, x[12], 25, 1804603682);
	//FF(d, a, b, c, x[13], 20, -40341101);
	//FF(c, d, a, b, x[14], 15, -1502002290);
	//FF(b, c, d, a, x[15], 10, 1236535329);


	///*************ڶ*****************/
	//GG(a, b, c, d, x[1], 27, -165796510);
	//GG(d, a, b, c, x[6], 23, -1069501632);
	//GG(c, d, a, b, x[11], 18, 643717713);
	//GG(b, c, d, a, x[0], 12, -373897302);

	//GG(a, b, c, d, x[5], 27, -701558691);
	//GG(d, a, b, c, x[10], 23, 38016083);
	//GG(c, d, a, b, x[15], 18, -660478335);
	//GG(b, c, d, a, x[4], 12, -405537848);

	//GG(a, b, c, d, x[9], 27, 568446438);
	//GG(d, a, b, c, x[14], 23, -1019803690);
	//GG(c, d, a, b, x[3], 18, -187363961);
	//GG(b, c, d, a, x[8], 12, 1163531501);

	//GG(a, b, c, d, x[13], 27, -1444681467);
	//GG(d, a, b, c, x[2], 23, -51403784);
	//GG(c, d, a, b, x[7], 18, 1735328473);
	//GG(b, c, d, a, x[12], 12, -1926607734);


	///******************************/
	//HH(a, b, c, d, x[5], 28, -378558);
	//HH(d, a, b, c, x[8], 21, -2022574463);
	//HH(c, d, a, b, x[11], 16, 1839030562);
	//HH(b, c, d, a, x[14], 9, -35309556);

	//HH(a, b, c, d, x[1], 28, -1530992060);
	//HH(d, a, b, c, x[4], 21, 1272893353);
	//HH(c, d, a, b, x[7], 16, -155497632);
	//HH(b, c, d, a, x[10], 9, -1094730640);

	//HH(a, b, c, d, x[13], 28, 681279174);
	//HH(d, a, b, c, x[0], 21, -358537222);
	//HH(c, d, a, b, x[3], 16, -722521979);
	//HH(b, c, d, a, x[6], 9, 76029189);

	//HH(a, b, c, d, x[9], 28, -640364487);
	//HH(d, a, b, c, x[12], 21, -421815835);
	//HH(c, d, a, b, x[15], 16, 530742520);
	//HH(b, c, d, a, x[2], 9, -995338651);



	///*******************************/
	//II(a, b, c, d, x[0], 26, -198630844);
	//II(d, a, b, c, x[7], 22, 1126891415);
	//II(c, d, a, b, x[14], 17, -1416354905);
	//II(b, c, d, a, x[5], 11, -57434055);

	//II(a, b, c, d, x[12], 26, 1700485571);
	//II(d, a, b, c, x[3], 22, -1894986606);
	//II(c, d, a, b, x[10], 17, -1051523);
	//II(b, c, d, a, x[1], 11, -2054922799);

	//II(a, b, c, d, x[8], 26, 1873313359);
	//II(d, a, b, c, x[15], 22, -30611744);
	//II(c, d, a, b, x[6], 17, -1560198380);
	//II(b, c, d, a, x[13], 11, 1309151649);

	//II(a, b, c, d, x[4], 26, -145523070);
	//II(d, a, b, c, x[11], 22, -1120210379);
	//II(c, d, a, b, x[2], 17, 718787259);
	//II(b, c, d, a, x[9], 11, -343485551);


	////ԭĽ
	//state[0] += a;
	//state[1] += b + c;
	//state[2] += c;
	//state[3] += d;
}

void __stdcall GetMD5(unsigned char * input, unsigned char * result)
{
	MD5_CTX md5;  //һMD5 text
	MD5Init(&md5);//ʼ           
	//unsigned char encrypt[] = "admin";//Ҫ
	//21232f297a57a5a743894a0e4a801fc3  
	MD5Update(&md5, input, strlen((char *)input));//г  
	unsigned char digest[16]; //ܽ     
	MD5Final(&md5, digest);   //кĲ㣬 
	//int resultLength = strlen((const char *)digest);
	int j = 0;
	for (int i = 0; i < 16; i++) {
		int t = digest[i];
		int a = t / 16;
		int b = t % 16;
		result[j + 0] = HEX[a];
		result[j + 1] = HEX[b];
		j += 2;
	}
	result[32] = '\0';
	//return decrypt;
}